%define name		tomcat5
%define full_name	jakarta-%{name}
%define version		5.0.27
%define majversion	5.0
%define release		2jpp_1rh
%define section		free

%define summary		Apache Servlet/JSP Engine, RI for Servlet 2.4/JSP 2.0 API
%define license		Apache Software License
%define distribution	JPackage
%define vendor		JPackage Project

%define jname		jasper5
%define tcuid		91

%define packname 	jakarta-tomcat-%{version}
%define packdname	jakarta-tomcat-%{version}-src

# FHS 2.2 compliant tree structure
# see http://www.pathname.com/fhs/2.2/
%define confdir		%{_sysconfdir}/%{name}
%define logdir		%{_localstatedir}/log/%{name}
%define homedir		%{_datadir}/%{name}
%define bindir		%{_datadir}/%{name}/bin
%define tempdir		%{_localstatedir}/cache/%{name}/temp
%define workdir		%{_localstatedir}/cache/%{name}/work
%define appdir		%{_localstatedir}/lib/%{name}/webapps
%define serverdir	%{_localstatedir}/lib/%{name}/server
%define commondir	%{_localstatedir}/lib/%{name}/common
%define shareddir	%{_localstatedir}/lib/%{name}/shared

Summary: 		%{summary}
Name: 			%{name}
Version: 		%{version}
Release: 		%{release}
Epoch:			0
License:		%{license}
#Vendor:			%{vendor}
#Distribution:		%{distribution}
Group: 			Networking/Daemons
URL: 			http://jakarta.apache.org/tomcat/
BuildArch: 		noarch
Source:			http://jakarta.apache.org/builds/jakarta-tomcat-5.0/release/v%{version}/src/%{packdname}.tar.gz
Source3:		TOMCAT4.README.RPM
Source4: 		%{name}-%{majversion}.init
Source5:		%{name}-%{majversion}.conf
Source6:		%{name}-%{majversion}.wrapper
Source7:		jasper5-%{majversion}.wrapper
Source8:		%{name}-%{majversion}.logrotate
Source9:		%{name}-%{majversion}.relink
Patch1:			tomcat5-%{version}.patch
Patch2:                 %{name}-%{majversion}.link_admin_jar.patch
Patch3:			%{name}-%{version}-no-jsvc-tar.patch
Patch4:			%{name}-%{version}-cluster-pathelement.patch
Patch5:			%{name}-%{version}-skip-build-on-install.patch
BuildRoot:		%{_tmppath}/%{name}-root-%{version}
Obsoletes:		tomcat tomcat-libs tomcat-devel tomcat-test

Requires:		ant >= 0:1.6.1, jpackage-utils >= 0:1.5.24
# xml parsing - isn't this already required by ant ?
Requires:		xerces-j2 >= 0:2.6.2
Requires:		xml-commons-apis
Requires:		regexp >= 0:1.3, tyrex = 0:1.0
# jakarta packages
Requires:		jakarta-commons-beanutils >= 0:1.4.1, jakarta-commons-collections >= 0:2.0
Requires:		jakarta-commons-daemon, jakarta-commons-dbcp >= 0:1.2.1, jakarta-commons-digester >= 0:1.3
Requires:		jakarta-commons-modeler, jakarta-commons-pool >= 0:1.1
Requires:		jakarta-commons-logging >= 0:1.0.4, jakarta-commons-fileupload >= 0:1.0-1jpp
Requires:		jakarta-commons-launcher >= 0:0.9, jakarta-commons-el >= 0:1.0
Requires:		mx4j >= 0:1.1.1
# alternatives
Requires:		jaas, jndi, jndi-ldap, jdbc-stdext
# non-free stuff
Requires:		jta >= 0:1.0.1-0.a.1, jaf >= 0:1.0.1, javamail >= 0:1.3
Requires:		servletapi5 >= 0:5.0.18

BuildRequires:		ant >= 0:1.6.1, xalan-j2
Buildrequires:		jpackage-utils >= 0:1.5.24
BuildRequires:		jakarta-commons-beanutils, jakarta-commons-collections >= 0:2.0
BuildRequires:		jakarta-commons-daemon, jakarta-commons-dbcp >= 0:1.2.1, jakarta-commons-digester >= 0:1.3
BuildRequires:		jakarta-commons-logging >= 0:1.0.4, jakarta-commons-fileupload >= 0:1.0
BuildRequires:		jakarta-commons-modeler, jakarta-commons-pool >= 0:1.1
BuildRequires:		jakarta-commons-launcher >= 0:0.9, jakarta-commons-el >= 0:1.0
BuildRequires:		jaas, jaf >= 0:1.0.1, javamail >= 0:1.3, jdbc-stdext >= 0:2.0
BuildRequires:		jndi >= 0:1.2.1, jndi-ldap, jsse >= 0:1.0.2, jta >= 0:1.0.1-0.a.1
BuildRequires:		junit >= 0:3.8.1
BuildRequires:		mx4j >= 0:1.1.1
BuildRequires:		regexp >= 0:1.3, puretls
BuildRequires:		struts >= 0:1.1, tyrex = 0:1.0, xerces-j2 >= 0:2.6.2, xml-commons-apis
BuildRequires:		jakarta-taglibs-standard >= 0:1.1.0
BuildRequires:		servletapi5 >= 0:5.0.18

%description
Server that conforms to the Servlet 2.4 and JSP 2.0
specifications from Java Software.

Develop Web applications in Java.

%package webapps
Group:			System Environment/Applications
Requires:		%{name} = %{epoch}:%{version}-%{release}
Requires:		jakarta-taglibs-standard >= 0:1.1.0
Summary:		Web Applications for tomcat

%description webapps
Web Applications for tomcat

%package admin-webapps
Group:			System Environment/Applications
Requires:		%{name} = %{epoch}:%{version}-%{release}
Requires:		struts >= 0:1.1
Summary:		Admin Web Applications for tomcat

%description admin-webapps
Admin Web Applications for tomcat


%prep
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%setup -q -c -T -a 0

cd %{packdname}
# %patch0
%patch1 -p2
%patch2 -p2
# %patch3 -p2 -b .nojsvc
%patch4 -p2 -b .cluster
%patch5 -p2 -b .skip

%build

export CLASSPATH=%(build-classpath xml-commons-apis xalan-j2)

# Remove pre-build jars
for dir in %{packdname} ; do
    find $dir -name "*.jar" -exec rm -f {} \;
done

pushd %{packdname}
cp $RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-tomcat-5/LICENSE .
popd 

# build jsp-api, servlet-api as ant dist will later on require them for webapps
pushd jakarta-tomcat-%{version}-src/jakarta-servletapi-5

pushd jsr154
ant -Dservletapi.build=build -Dservletapi.dist=dist -Dbuild.compiler=modern dist
popd

pushd jsr152
ant -Dservletapi.build=build -Dservletapi.dist=dist -Dbuild.compiler=modern dist
popd

popd


# build tomcat 5
pushd %{packdname}/jakarta-tomcat-5

cat >> build.properties <<EOBP
ant.jar=%{_javadir}/ant.jar
ant-launcher.jar=%{_javadir}/ant.jar
jtc.home=$RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-tomcat-connectors/
jasper.home=$RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-tomcat-jasper/jasper2
commons-beanutils.jar=$(build-classpath commons-beanutils)
commons-fileupload.jar=$(build-classpath commons-fileupload)
commons-collections.jar=$(build-classpath commons-collections)
commons-daemon.jar=$(build-classpath commons-daemon)
commons-dbcp.jar=$(build-classpath commons-dbcp)
commons-digester.jar=$(build-classpath commons-digester)
commons-el.jar=$(build-classpath commons-el)
commons-launcher.jar=$(build-classpath commons-launcher)
commons-logging.jar=$(build-classpath commons-logging)
commons-logging-api.jar=$(build-classpath commons-logging-api)
commons-modeler.jar=$(build-classpath commons-modeler)
commons-pool.jar=$(build-classpath commons-pool)
jmx.jar=$(build-classpath jmxri)
jmx-tools.jar=$(build-classpath mx4j/mx4j-tools.jar)
jmxri.jar=$(build-classpath jmxri)
junit.jar=$(build-classpath junit)
regexp.jar=$(build-classpath regexp)
servlet-api.jar=$(build-classpath servletapi5)
jsp-api.jar=$(build-classpath jspapi)
servlet.doc=%{_javadocdir}/servletapi5
xercesImpl.jar=$(build-classpath jaxp_parser_impl)
xml-apis.jar=$(build-classpath xml-commons-apis)
struts.jar=$(build-classpath struts)
struts.lib=%{_datadir}/struts
activation.jar=$(build-classpath jaf)
mail.jar=$(build-classpath javamail/mailapi)
jta.jar=$(build-classpath jta)
tyrex.jar=$(build-classpath tyrex)
jaas.jar=$(build-classpath jaas)
jndi.jar=$(build-classpath jndi)
jdbc20ext.jar=$(build-classpath jdbc-stdext)
puretls.jar=$(build-classpath puretls)
jcert.jar=$(build-classpath jsse/jcert)
jnet.jar=$(build-classpath jsse/jnet)
jsse.jar=$(build-classpath jsse/jsse)
servletapi.build.notrequired=true
jspapi.build.notrequired=true
EOBP

# can't use jikes to build tomcat5 (strange)
ant -Dbuild.compiler=modern -Djava.home=%{java_home} build

popd

# build the connectors
pushd %{packdname}/jakarta-tomcat-connectors

# this is just plain and simply evil but something changed in a major way between 5.0.16 and 5.0.18
export CLASSPATH=$RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-servletapi-5/jsr154/dist/lib/servlet-api.jar:\
$RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src/jakarta-tomcat-5/build/server/lib/catalina.jar

cat > build.properties <<EOBP
activation.jar=$(build-classpath jaf)
ant.jar=%{_javadir}/ant.jar
junit.jar=$(build-classpath junit)
commons-beanutils.jar=$(build-classpath commons-beanutils)
commons-collections.jar=$(build-classpath commons-collections)
commons-daemon.jar=$(build-classpath commons-daemon)
commons-digester.jar=$(build-classpath commons-digester)
commons-fileupload.jar=$(build-classpath commons-fileupload)
commons-logging.jar=$(build-classpath commons-logging)
commons-logging-api.jar=$(build-classpath commons-logging-api)
commons-modeler.jar=$(build-classpath commons-modeler)
commons-pool.jar=$(build-classpath commons-pool)
regexp.jar=$(build-classpath regexp)
jmx.jar=$(build-classpath mx4j/mx4j-jmx)
puretls=$(build-classpath puretls)
activation.jar=$(build-classpath jaf)
mail.jar=$(build-classpath javamail/mailapi)
jta.jar=$(build-classpath jta)
tyrex.jar=$(build-classpath tyrex)
jaas.jar=$(build-classpath jaas)
jndi.jar=$(build-classpath jndi)
jdbc20ext.jar=$(build-classpath jdbc-stdext)
puretls.jar=$(build-classpath puretls)
jcert.jar=$(build-classpath jsse/jcert)
jnet.jar=$(build-classpath jsse/jnet)
jsse.jar=$(build-classpath jsse/jsse)
EOBP
ant -Dbuild.compiler=modern -Djava.home=%{java_home} build
                                                                                                                                                                                                 
popd


%install
rm -rf $RPM_BUILD_ROOT

# install RPM README
cp %{SOURCE3} .

export CLASSPATH=%(build-classpath xalan-j2 xml-commons-apis jakarta-taglibs-core jakarta-taglibs-standard jspapi)

# build initial path structure
install -d -m 755 $RPM_BUILD_ROOT/{%{confdir},%{logdir},%{homedir},%{bindir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{serverdir},%{tempdir},%{workdir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{appdir},%{commondir},%{shareddir}}

install -d -m 755 $RPM_BUILD_ROOT/{%{_bindir},%{_sysconfdir}/{init.d,logrotate.d},%{_javadir}}

install -m 755 %{SOURCE9} $RPM_BUILD_ROOT/%{bindir}/relink

# sysv init and logging
install %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name}
install %{SOURCE5} $RPM_BUILD_ROOT/%{confdir}/%{name}.conf

pushd %{packdname}/jakarta-tomcat-5
export usejikes=false
ant -Dbuild.compiler=modern -Djava.home=%{java_home} dist

pushd dist
    mv bin/*     ${RPM_BUILD_ROOT}%{bindir}
    mv common/*  ${RPM_BUILD_ROOT}%{commondir}
    mv conf/*    ${RPM_BUILD_ROOT}%{confdir}
    mv server/*  ${RPM_BUILD_ROOT}%{serverdir}
    mv shared/*  ${RPM_BUILD_ROOT}%{shareddir}
    mv webapps/* ${RPM_BUILD_ROOT}%{appdir}
popd

# create reloctomcat5
cat >> $RPM_BUILD_ROOT%{bindir}/reloctomcat5<<EORLTC
#!/bin/sh
#

echo "relocating http & ajp ports to 81xx"

sed -e 's;8080;8180;' \
    -e 's;8081;8181;' \
    -e 's;8082;8182;' \
    -e 's;8443;8543;' \
    -e 's;8009;8109;' \
    %{confdir}/server.xml > %{confdir}/server.xml.reloc

mv %{confdir}/server.xml %{confdir}/server.xml.bak
cp %{confdir}/server.xml.reloc %{confdir}/server.xml

EORLTC

# rename catalina/jasper into dtomcat5/djasper5 to let wrapper take precedence
install $RPM_BUILD_ROOT%{bindir}/catalina.sh $RPM_BUILD_ROOT%{_bindir}/d%{name}
rm -f $RPM_BUILD_ROOT%{bindir}/catalina.sh.*
# Remove leftover files ?
rm -f $RPM_BUILD_ROOT%{bindir}/*.orig

# install wrapper as tomcat5/jasper5
install %{SOURCE6} $RPM_BUILD_ROOT%{_bindir}/%{name}
install %{SOURCE7} $RPM_BUILD_ROOT%{_bindir}/%{jname}

# install logrotate support
install %{SOURCE8} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}

# remove / reorder non-usefull stuff
rm -rf $RPM_BUILD_ROOT%{homedir}/src/
rm -f  $RPM_BUILD_ROOT%{bindir}/*.sh $RPM_BUILD_ROOT%{bindir}/*.bat

# FHS compliance patches, not easy to track them all boys :)

for i in $RPM_BUILD_ROOT%{confdir}/%{name}.conf $RPM_BUILD_ROOT%{_bindir}/d%{name} \
         $RPM_BUILD_ROOT%{_bindir}/%{name} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name} \
         $RPM_BUILD_ROOT%{_bindir}/d%{jname} $RPM_BUILD_ROOT%{_bindir}/%{jname} \
         $RPM_BUILD_ROOT%{bindir}/relink $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/%{name}
    do

    perl -pi -e "s|\@\@\@TCCONF\@\@\@|%{confdir}|g;" $i
    perl -pi -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g;" $i
    perl -pi -e "s|\@\@\@TCBIN\@\@\@|%{bindir}|g;" $i
    perl -pi -e "s|\@\@\@TCCOMMON\@\@\@|%{commondir}|g;" $i
    perl -pi -e "s|\@\@\@TCSERVER\@\@\@|%{serverdir}|g;" $i
    perl -pi -e "s|\@\@\@TCSHARED\@\@\@|%{shareddir}|g;" $i
    perl -pi -e "s|\@\@\@TCAPP\@\@\@|%{appdir}|g;" $i
    perl -pi -e "s|\@\@\@TCLOG\@\@\@|%{logdir}|g;" $i
done

### Replace local copies with jpp-compatible links
# Process server/lib
pushd   $RPM_BUILD_ROOT/%{serverdir}/lib
    find . -name "*.jar" -not -name "catalina*" \
                         -not -name "servlets-*" \
                         -not -name "tomcat-*" \
                         -exec rm -f {} \;

    # catalina-ant will be installed in a public repository
    mv catalina-ant.jar $RPM_BUILD_ROOT/%{_javadir}/catalina-ant-%{version}.jar

    pushd $RPM_BUILD_ROOT/%{_javadir}
        ln -fs catalina-ant-%{version}.jar catalina-ant5.jar
    popd
popd

# Process admin webapp server/webapps/admin
# don't remove catalina-admin though
pushd $RPM_BUILD_ROOT/%{serverdir}/webapps/admin/WEB-INF/lib
    find . -name "*.jar" -not -name 'catalina-admin*' -exec rm -f {} \;
popd

# Process common/lib
pushd $RPM_BUILD_ROOT/%{commondir}/lib
    find . -name "*.jar" -not -name "jasper*" \
                         -not -name "naming*" \
                         -exec rm -f {} \;
popd

# Process common/lib
pushd $RPM_BUILD_ROOT/%{commondir}/endorsed
    find . -name "*.jar" -exec rm -f {} \;
popd

# avoid duplicate servlet.jar
rm -f $RPM_BUILD_ROOT%{commondir}/lib/servlet.jar

# Perform FHS translation
# (final links)
pushd $RPM_BUILD_ROOT%{homedir}
   [ -d bin ]     || ln -fs %{bindir}    bin
   [ -d common ]  || ln -fs %{commondir} common
   [ -d conf ]    || ln -fs %{confdir}   conf
   [ -d logs ]    || ln -fs %{logdir}    logs
   [ -d server ]  || ln -fs %{serverdir} server
   [ -d shared ]  || ln -fs %{shareddir} shared
   [ -d webapps ] || ln -fs %{appdir}    webapps
   [ -d work ]    || ln -fs %{workdir}   work
   [ -d temp ]    || ln -fs %{tempdir}   temp
popd

cd $RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-%{version}-src
find $RPM_BUILD_ROOT%{homedir} -type l -maxdepth 1 | sed s+$RPM_BUILD_ROOT++g > homelinks




%clean
rm -rf $RPM_BUILD_ROOT


%post
# install tomcat5 (but don't activate)
/sbin/chkconfig --add %{name}

### Create automated links
### Since all needed extensions may not have been installed for this jvm
### output is muted

# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat5.conf ] && . %{confdir}/tomcat5.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java

# Remove old automated symlinks
# we do not want old links if a jar is removed from tomcat's layout
for repository in %{serverdir}/lib \
                  %{commondir}/lib \
                  %{commondir}/endorsed ; do
    find $repository -name '\[*\]*.jar' -not -type d -exec rm -f {} \;
done

build-jar-repository %{serverdir}/lib commons-beanutils commons-fileupload \
                                      commons-digester commons-logging \
                                      commons-modeler commons-el regexp jmxri jaas \
                                      catalina-ant5 2>&1

build-jar-repository %{commondir}/lib ant commons-collections commons-dbcp \
                                      commons-pool commons-logging-api commons-el\
                                      jaf jdbc-stdext jta javamail jndi jmxri \
                                      jspapi servletapi5 2>&1

build-jar-repository %{commondir}/endorsed jaxp_parser_impl xml-commons-apis 2>&1


%post webapps 
                                                                                                                                                                                                  
### Create automated links
### Since all needed extensions may not have been installed for this jvm
### output is muted
                                                                                                                                                                                                  
# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat5.conf ] && . %{confdir}/tomcat5.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java

build-jar-repository %{appdir}/jsp-examples/WEB-INF/lib \
      jakarta-taglibs-core jakarta-taglibs-standard 2>&1


%post admin-webapps

### Create automated links
### Since all needed extensions may not have been installed for this jvm
### output is muted

# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat5.conf ] && . %{confdir}/tomcat5.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java

# Remove old automated symlinks
# we do not want old links if a jar is removed from tomcat's layout
find %{serverdir}/webapps/admin/WEB-INF/lib -name '\[*\]*.jar' \
     -not -name 'catalina-admin*' -not -type d -exec rm -f {} \;

build-jar-repository %{serverdir}/webapps/admin/WEB-INF/lib struts 2>&1


%preun
# Always clean up wordir and tempdir on upgrade/removal
rm -fr %{workdir}/* %{tempdir}/*

if [ $1 = 0 ]; then
    [ -f /var/lock/subsys/%{name} ] && %{_sysconfdir}/init.d/%{name} stop
    [ -f %{_sysconfdir}/init.d/%{name} ] && /sbin/chkconfig --del %{name}

    # NEVER remove a serve system user and group from the system
    # You can leave orphaned files behind
    #%{_sbindir}/userdel tomcat >> /dev/null 2>&1 || :
    #%{_sbindir}/groupdel tomcat >> /dev/null 2>&1 || :

    # Remove automated symlinks
    for repository in %{serverdir}/lib \
                      %{commondir}/lib \
                      %{commondir}/endorsed ; do
        find $repository -name '\[*\]*.jar' -not -type d -exec rm -f {} \;
    done
fi


%preun admin-webapps

if [ $1 = 0 ]; then
    find %{serverdir}/webapps/admin/WEB-INF/lib  \
         -name '\[*\]*.jar' \
         -not -name 'catalina-admin*' -not -type d -exec rm -f {} \;
fi

%preun webapps

if [ $1 = 0 ]; then
    find %{appdir}/jsp-examples/WEB-INF/lib  \
         -name '\[*\]*.jar' \
         -not -type d -exec rm -f {} \;
fi



%pre
# Add the "tomcat" user and group
# we need a shell to be able to use su - later
%{_sbindir}/groupadd -g %{tcuid} -r tomcat 2> /dev/null || :
%{_sbindir}/useradd -c "Tomcat" -u %{tcuid} -g tomcat \
    -s /bin/sh -r -d %{homedir} tomcat 2> /dev/null || :


%files -f %{packdname}/homelinks
%defattr(644,root,root,755)
%doc TOMCAT4.README.RPM %{packdname}/jakarta-tomcat-5/{LICENSE,RELE*,RUNNING.txt,BENCHMARKS.txt}
# Normal directories
%dir %{homedir}
%dir %{bindir}
%dir %{_localstatedir}/lib/%{name}
%dir %{_localstatedir}/cache/%{name}
%dir %{commondir}
%dir %{serverdir}
%dir %{serverdir}/classes
%dir %{serverdir}/lib
%dir %{shareddir}
%dir %{shareddir}/classes
%dir %{shareddir}/lib

%{_javadir}/*.jar

# Directories with special permissions
%attr(775,root,tomcat)		%dir                  %{appdir}
%attr(775,root,tomcat)    	%dir                  %{confdir}
%attr(775,root,tomcat)    	%dir                  %{tempdir}
%attr(775,root,tomcat)    	%dir                  %{workdir}
%attr(755,tomcat,tomcat)	%dir                  %{logdir}
%attr(775,root,tomcat)     %dir                  %{confdir}/Catalina
%attr(775,root,tomcat)     %dir                  %{confdir}/Catalina/localhost

%attr(755,root,root) 	  	%{_bindir}/*
%attr(755,root,root) 	  	%{bindir}/*
%attr(755,root,root)  	  	%{_sysconfdir}/init.d/%{name}

%attr(644,root,tomcat)    	%config(noreplace)      %{confdir}/catalina.policy
%attr(644,root,tomcat)    	%config(noreplace)      %{confdir}/catalina.properties
%attr(660,root,tomcat)    	%config(noreplace)      %{confdir}/jk2.properties
%attr(660,root,tomcat)    	%config(noreplace)      %{confdir}/tomcat-users.xml
%config(noreplace) %{confdir}/tomcat5.conf
%config(noreplace) %{confdir}/server-minimal.xml
%config(noreplace) %{confdir}/server.xml
%config(noreplace) %{confdir}/web.xml

# %{confdir}/server-noexamples.xml.config
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{commondir}/*
%{serverdir}/lib/*
# %{tempdir}/README.txt

%files webapps
%defattr(644,root,tomcat,775)
%dir %{appdir}/servlets-examples
%{appdir}/servlets-examples/*
%dir %{appdir}/jsp-examples
%{appdir}/jsp-examples/*
%dir %{appdir}/ROOT
%{appdir}/ROOT/*
%dir %{appdir}/tomcat-docs
%{appdir}/tomcat-docs/*
%dir %{appdir}/webdav
%{appdir}/webdav/*

%files admin-webapps
%defattr(640,root,tomcat,750)
%attr(660,root,tomcat) %{confdir}/Catalina/localhost/manager.xml
%{confdir}/Catalina/localhost/balancer.xml
%{confdir}/Catalina/localhost/admin.xml
%dir %{appdir}/balancer
%{appdir}/balancer/*
%defattr(644,root,tomcat,750)
%dir %{serverdir}/webapps
%{serverdir}/webapps/*

%changelog
* Wed Jul 21 2004 Fernando Nasser <fnasser@redhat.com> 0:5.0.27-2jpp_1rh
- Merge with more recent community version

* Fri Jul 16 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.27-2jpp
- Oops, don't require mx4j 2.0.1. 1.1.1 or later should be enough.
  jmxri won't work anymore since tc5 needs mx4j-tools.

* Fri Jul 16 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.27-1jpp
- Update to 5.0.27 (stable)
- Don't remove tomcat4 user/group on uninstall see the mailing list
  for discussion
- build w/ xml-apis.jar instead of xmlParserAPIs.jar (release notes 5.0.27)
- Require junit 3.8.1 or newer (release notes 5.0.26)
- Require jakarta-commons-dbcp 1.2.1 or newer (release notes 5.0.27)
- Require jakarta-commons-logging 1.0.4 or newer (release notes 5.0.27)
- Require jakarta-commons-pool 1.1 or newer (release notes 5.0.27)

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:5.0.24-2jpp
- Upgrade to Ant 1.6.X

* Mon May 17 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.24-1jpp
- Update to 5.0.24
- Require xerces-j2 2.6.2 (release notes 5.0.21), also require ant < 1.6
  as tomcat5 doesn't seem to build cleanly with 1.6 yet.

* Wed Apr 08 2004 Fernando Nasser <fnasser@redhat.com> 0:5.0.19-2jpp_3rh
- Fix name of the Tomcat user to 'tomcat' and update other tomcat4 references
  to tomcat5.

* Wed Apr 08 2004 Fernando Nasser <fnasser@redhat.com> 0:5.0.19-2jpp_2rh
- Allow browsing of webapps directory so that JOnAS can build.

* Wed Apr 08 2004 Fernando Nasser <fnasser@redhat.com> 0:5.0.19-2jpp_1rh
- Red Hat customizations
- remove references to sun.com classes
- user and group are 'tomcat' with no versioning
- do not remove user and group on uninstall
- relax some directory and file permissions so that JOnAS can access them

* Fri Mar 19 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.19-2jpp
- Set JAVA_ENDORSED_DIRS by default in tomcat5.conf, it is otherwise empty
  Suggestion from Aleksander Adamowski <aleksander.adamowski@altkom.pl>  

* Wed Feb 25 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.19-1jpp
- Update to 5.0.19

* Fri Jan 23 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.18-1jpp
- Update to 5.0.18
- Build catalina before connectors
- Hack connectors build
- Require xerces-j2 2.6.0 (release notes 5.0.17)

* Sat Jan 17 2004 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-4jpp
- Create TC4 user and group separately, lets TC5 work out of the box
  on Trustix (Patch from Iain Arnell)

* Sat Jan 10 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-3jpp
- servletapi5 is required
- move confdir/Catalina from admin-webapps to main package
  (otherwise we end up requiring tomcat5-admin-webapps for struts-webapps)

* Sat Jan 10 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-2jpp
- Fix conflict with tomcat4 catalina-ant.jar in %%_javadir by renaming it
  catalina-ant5.jar for now.

* Fri Jan  9 2004 Kaj J. Niemi <kajtzu@fi.basen.net> - 0:5.0.16-1jpp
- First build for JPackage

* Mon Dec 29 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.11
- Merge changes from tomcat4.init to tomcat5.init

* Mon Dec 22 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.10
- Some jsp-examples require jakarta-taglibs-standard to work

* Mon Dec 22 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.9.1
- Struts should be 1.1 or later according to the release notes
- The /admin webapp works now as well
- manager.xml needs to be group writeable, otherwise tomcat complains

* Fri Dec 19 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.7
- Accept an older version of xerces-j2 as well.

* Fri Dec 19 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.6
- Require xerces-j2 instead of just jaxp_parser_impl
- Require jpackage commons-logging instead of internal version

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.5
- Tomcat5 isn't beta anymore

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.beta.4
- Place jspapi, jmxri, commons-el in common/lib as mentioned in the
  upstream RELEASE-NOTES.txt. This makes jsps actually work.

* Wed Dec 17 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.beta.3
- Separated jakarta-commons-el from tomcat
- Require servletapi5 and jakata-commons-el
- Added Patch #4 (tomcat5-5.0.16-cluster-pathelement.patch) which fixes
  build failure when servlet-api is renamed something else than the default
- Added Patch #5 (tomcat5-5.0.16-skip-build-on-install.patch) which corrects
  servletapi/jspapi related build snafu on install. They're already built so
  it's OK to skip.

* Thu Dec  4 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.16-0.beta.1
- 5.0.16
- jakarta-commons-el included here instead of somewhere else for now,
  packaging unfinished
- Patch #3 removes dependency to jsvc.tar.gz which doesn't seem to be anywhere

* Tue Aug  5 2003 Kaj J. Niemi <kajtzu@fi.basen.net> 0:5.0.12-0.beta.1
- Based on JPackage.org's tomcat4 .spec
- No compat stuff anymore.
- First build

